freeslot("S_METALNEGAEXPLDE1", "S_METALNEGAEXPLDE2", "S_METALNEGAEXPLDE3", "S_METALNEGAEXPLDE4", "S_METALNEGAEXPLDE5", "S_METALNEGAEXPLDE6", 
"S_METALNEGAEXPLDE7")

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "metalnega")
			if CBW_Battle
				player.charability = CA_FLOAT
			else
				player.charability = CA_NONE
			end
			if not (player.mo.negadash)
				player.mo.negadash = 0
			end
			if player.mo.negadash > 0
				player.mo.negadash = $1 - 1
			end
			if not (player.mo.negajump)
				player.mo.negajump = 0
			end
			if player.mo.negajump > 0
				player.mo.negajump = $1 - 1
			end
			if player.mo.negadash
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.momz = 0
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				player.pflags = $1 & ~PF_SPINNING
				player.mo.state = S_PLAY_DASH
				player.drawangle = player.mo.angle
				local aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				aura.color = SKINCOLOR_RED
				aura.colorized = true
				aura.blendmode = AST_ADD
				local electric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				electric.color = SKINCOLOR_RED
				electric.colorized = true
				electric.blendmode = AST_ADD
				electric.state = S_WATERZAP
				local boostdash = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				boostdash.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_KETCHUP)
				boostdash.colorized = true
				boostdash.blendmode = AST_ADD
				boostdash.sprite = SPR_FIRS
				boostdash.frame = S|FF_TRANS50
				boostdash.angle = player.mo.angle
				boostdash.fuse = 1
				P_StartQuake(FRACUNIT, 1)
				if player.mo.eflags & MFE_VERTICALFLIP
					boostdash.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(boostdash, boostdash.x, boostdash.y, boostdash.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
				if (player.mo.eflags & MFE_UNDERWATER)
					if player.powers[pw_sneakers]
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT/1)
					else
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT/2)
					end
				else
					if player.powers[pw_sneakers]
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT*1)
					else
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					end
				end
			end
			if player.mo.negadash == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.state = S_PLAY_FALL
				player.pflags = $ & ~PF_DRILLING
				player.pflags = $ & ~PF_JUMPED
				S_StartSound(player.mo, sfx_skid)
				if not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/2)
				elseif (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/3)
				end
			end
			if player.mo.negadash >= 1
			and not P_PlayerInPain(player)
			and (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.negadash = 0
				player.mo.state = S_PLAY_WALK
			end
			if player.mo.negajump >= 1
			and not P_PlayerInPain(player)
			and (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.negajump = 0
				player.mo.state = S_PLAY_SPRING
				if (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, 10*FRACUNIT/2, false)
				else
					P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
				end
				S_StartSound(player.mo,sfx_s3k59)
				for i = 1, 30
					local debris_nega = P_SPMAngle(player.mo, MT_GROUNDPOUND, FixedAngle(12*FRACUNIT)*i, 0)
					if debris_nega and debris_nega.valid
						P_InstaThrust(debris_nega, player.mo.angle+(ANGLE_45*i), 35*FRACUNIT)
						debris_nega.colorized = true
						debris_nega.sttspeed = 2
						debris_nega.tics = 30
						debris_nega.color = player.skincolor
					end
				end
			end
			if player.mo.state == S_PLAY_PAIN
				player.mo.negajump = 0
			end
			if player.mo.negajump > 1
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				player.mo.negajump = 5
				player.mo.swordcooldown = 5
				player.mo.usedown = 1
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				if (leveltime & 3) == 1
					P_SetObjectMomZ(player.mo, -5*FRACUNIT, 1)
					player.mo.state = S_PLAY_ROLL
				else
					player.mo.state = S_PLAY_ROLL
				end
				if (player.mo.eflags & MFE_GOOWATER)
					player.mo.negajump = 0
					player.mo.state = S_PLAY_FALL
				end
			end
			if player.mo.negajump >= 1
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				if (P_IsObjectOnGround(player.mo))
					player.mo.negajump = 0
					player.mo.state = S_PLAY_WALK
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
			or player.powers[pw_carry]
			or P_PlayerInPain(player)
			or player.exiting
				player.mo.negadash = 0
				player.mo.negajump = 0
			end
			if P_PlayerInPain(player)
			or (CBW_Battle and (player.tumble != nil and player.tumble > 0)) //Tumble Fix
			or player.playerstate == PST_DEAD
			or player.mo.state == S_PLAY_PAIN
			or player.mo.sprite2 == SPR2_PAIN
			or player.exiting
				player.mo.negadash = 0
				player.mo.negajump = 0
			end
		end
		if player.mo and player.mo.valid and player.mo.skin != "metalnega"
			if player.mo.negajump
				player.mo.negajump = nil
			end
			if player.mo.negadash
				player.mo.negadash = nil
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.skin != "metalnega"
	and player.playerstate == PST_LIVE
		player.mo.negajump = nil
		player.mo.negadash = nil
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.mo and player.mo.skin == "metalnega"
		if player.mo.negadash
		or player.mo.negajump then 
			return true
		end
	end
end)

local function metalnega_FixedLerp(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end

addHook("PostThinkFrame", function()
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "metalnega"
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not P_PlayerInPain(player)
		and not player.exiting
			if player.mo.negadash > 1
			or player.mo.negajump > 1
				local ghost5 = P_SpawnGhostMobj(player.mo)
				ghost5.color = SKINCOLOR_PASTEL
				ghost5.colorized = true
				ghost5.fuse = 1
				ghost5.blendmode = AST_ADD
				P_TeleportMove(ghost5, player.mo.x, player.mo.y, player.mo.z - 4*FRACUNIT)
				ghost5.frame = $|FF_ADD
				ghost5.scale = 1*FRACUNIT + 1*FRACUNIT/6
				if ghost5.tracer
					ghost5.tracer.fuse = ghost5.fuse
				end
			end
		end
	end
	for player in players.iterate()
		local mo = player.mo
		if not (mo and mo.valid and mo.skin == "metalnega") continue end
		if (player == nil) or (player.playerstate != PST_LIVE) continue end
		
		if (mo.metalnega_previousx == nil) or (mo.metalnega_previousy == nil) or (mo.metalnega_previousz == nil)
			mo.metalnega_previousx = mo.x
			mo.metalnega_previousy = mo.y
			mo.metalnega_previousz = mo.z
		end
		//Used Rebound Dash
		if player.mo.negadash > 1
		or player.mo.negajump > 1
		and not player.exiting
			for i = 0, 9
				local percent = FRACUNIT * (i * 10) / 100
				local trail = P_SpawnGhostMobj(mo)
				local metalnega_tx = metalnega_FixedLerp(mo.x,mo.metalnega_previousx,percent)
				local metalnega_ty = metalnega_FixedLerp(mo.y,mo.metalnega_previousy,percent)
				local metalnega_tz = metalnega_FixedLerp(mo.z + 3*FRACUNIT,mo.metalnega_previousz + 4*FRACUNIT,percent)
				P_TeleportMove(trail, metalnega_tx, metalnega_ty, metalnega_tz - 7 * FRACUNIT)
				trail.fuse = 4
				trail.color = SKINCOLOR_RED
				trail.scalespeed = mo.scale/5
				trail.scale = mo.scale - (i * FRACUNIT/120)
				trail.destscale = 0
				trail.blendmode = AST_ADD
				if trail.tracer and trail.tracer.valid
					P_TeleportMove(trail.tracer, metalnega_tx, metalnega_ty, metalnega_tz - 7 * FRACUNIT)
					trail.tracer.fuse = 4
					trail.tracer.color = SKINCOLOR_RED
					trail.tracer.scalespeed = mo.scale/5
					trail.tracer.scale = mo.scale - (i * FRACUNIT/120)
					trail.tracer.destscale = 0
					trail.tracer.blendmode = AST_ADD
				end
			end
		end
		mo.metalnega_previousx = mo.x
		mo.metalnega_previousy = mo.y
		mo.metalnega_previousz = mo.z
	end
end)

addHook("MobjDamage", function(enemy, inf)
	if enemy and enemy.valid
		if enemy.flags & MF_ENEMY or enemy.flags & MF_BOSS or enemy.flags & MF_MONITOR
			if enemy.health > 1
				if inf and inf.valid and inf.skin == "metalnega" and inf.player
					if inf.negajump > 1
						local negapunch = P_SpawnMobj(inf.x, inf.y, inf.z, MT_THOK)
						negapunch.state = S_METALNEGAEXPLDE1
						negapunch.color = SKINCOLOR_PASTEL
						negapunch.colorized = true
						negapunch.blendmode = AST_ADD
						negapunch.scale = 1*FRACUNIT/2
						negapunch.target = inf
						negapunch.frame = $ & ~FF_TRANSMASK | TR_TRANS50
						inf.state = S_PLAY_SPRING
						inf.negajump = 0
						inf.player.pflags = $1 & ~PF_THOKKED
					end
				end
			end
		end
	end
end)

addHook("MobjDeath", function(enemy, inf)
	if enemy and enemy.valid
		if enemy.flags & MF_ENEMY or enemy.flags & MF_BOSS or enemy.flags & MF_MONITOR
			if inf and inf.valid and inf.skin == "metalnega" and inf.player
				if inf.negajump > 1
					local negapunch = P_SpawnMobj(inf.x, inf.y, inf.z, MT_THOK)
					negapunch.state = S_METALNEGAEXPLDE1
					negapunch.color = SKINCOLOR_PASTEL
					negapunch.colorized = true
					negapunch.blendmode = AST_ADD
					negapunch.scale = 1*FRACUNIT/2
					negapunch.target = inf
					negapunch.frame = $ & ~FF_TRANSMASK | TR_TRANS50
					inf.state = S_PLAY_SPRING
					inf.negajump = 0
					inf.player.pflags = $1 & ~PF_THOKKED
				end
			end
		end
	end
end)

addHook("ShouldDamage", function(mo, inf)
	if mo and mo.valid and mo.player
		if inf and inf.valid and inf.skin == "metalnega" and inf.player
			if CBW_Battle
				if inf.negajump > 1
					local negapunch = P_SpawnMobj(inf.x, inf.y, inf.z, MT_THOK)
					negapunch.state = S_METALNEGAEXPLDE1
					negapunch.color = SKINCOLOR_PASTEL
					negapunch.colorized = true
					negapunch.blendmode = AST_ADD
					negapunch.scale = 1*FRACUNIT/2
					negapunch.target = inf
					negapunch.frame = $ & ~FF_TRANSMASK | TR_TRANS50
					inf.state = S_PLAY_SPRING
					inf.negajump = 0
					inf.player.pflags = $1 & ~PF_THOKKED
				end
			end
		end
	end
end, MT_PLAYER)

local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
		BattleFuncSet = true
		local metalnegaPriority = function(player)
			if player.mo.negajump
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"Mach Pound")
			end
			if player.mo.negadash
				CBW_Battle.SetPriority(player,1,2,nil,1,2,"Flare Thrust")
			end
		end
		local metalnegaBattle = function(mo,doaction,pressedaction)
			local player = mo.player
			if mo.negadash
			or mo.negajump
				player.canguard = false
			end
			//if not(CBW_Battle.CanDoAction(player))
				//player.actionstate = 0
				//player.canguard = false
				//return
			//end
			if P_IsObjectOnGround(mo)
				player.actiontext = "Mach Speed Slam"
				player.actionrings = 10	
			else
				if player.cmd.buttons & BT_JUMP
				and (player.pflags & PF_THOKKED)
					player.actiontext = "Mach Speed Slam"
					player.actionrings = 10
				else
					player.actiontext = "Flare Thrust"
					player.actionrings = 10
				end
			end
			if player.actionstate != 0
				player.canguard = false
			end
			if player.actionstate == 0
				if doaction == 1
					CBW_Battle.PayRings(player)
					if P_IsObjectOnGround(mo)
						S_StartSound(mo, sfx_rail1)
						S_StartSound(mo, sfx_rail2)
						S_StartSound(mo, sfx_spin)
						mo.negajump = 5
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 30*FRACUNIT/2, false)
						else
							P_SetObjectMomZ(player.mo, 30*FRACUNIT, false)
						end
						CBW_Battle.ApplyCooldown(player, 3*TICRATE)
					else
						if player.cmd.buttons & BT_JUMP
						and (player.pflags & PF_THOKKED)
							P_ResetPlayer(player)
							S_StartSound(mo, sfx_rail1)
							S_StartSound(mo, sfx_rail2)
							S_StartSound(mo, sfx_spin)
							mo.negajump = 5
							if (player.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
							else
								P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
							end
							CBW_Battle.ApplyCooldown(player, 3*TICRATE)
						else
							S_StartSound(mo, sfx_rail1)
							S_StartSound(mo, sfx_rail2)
							P_ResetPlayer(player)
							mo.negadash = 30
							CBW_Battle.ApplyCooldown(player,TICRATE*4+15)
						end
					end
				end
			end
		end
	CBW_Battle.SkinVars["metalnega"] = {
		weight = 100,
		special = metalnegaBattle,
		func_priority_ext = metalnegaPriority
	}
	print("\x85 Metal Sonic 3.0'\x80 Battle Mode support has been added!")
end)